// Course:    IE 170/171, Laboratory 12
// File name: SearchMatch.cpp
// Author:    Meredith Somers
// Revision:  scott, asm4: Spring/05
// Purpose:   Locate a search string in Text using different algorithms
// Usage:     executable inputFileName [SearchStringListFilename]
//            For MS VS6.0 user:
//            (1) Create a project, add this file.
//            (2) Open Project menu --> Settings --> Debug, 
//                type data file name (input.txt) into Program Arguments
//                column. 
//#############################################################################

#include "StringMatch.hpp"
#include <fstream>
#include <cmath>

/*===========================================================================*/
/*====================== Constructors and Destructors =======================*/
/*===========================================================================*/
StringMatch::StringMatch(ifstream &is)
{
  char temp;
  int i(0);
  while((temp = is.get()) != -1){
    Text += temp;
    i++;
  }
  cout << "Input string length = " << i << endl;
  is.close();
}

/*===========================================================================*/
/*===========================================================================*/
void StringMatch::NaiveMatcher(string P)
{
  int n = Text.length();	// Lenght of the whole Text
  int m = P.length();		// Length of the whole Search String
  int count(0);			// Counts # matches
  
  ofstream outfile(OUTFILE, ios::app); // append to output file
  for (int s = 0; s <= n-m; s++) {
    int j = 0;
    while (j < m && P[j] == Text[s+j]){
      ++j;
    }
		
    if (j == m){
      outfile<< P <<" occurs with shift "<<s<<endl;
      count++;
    }
  }
  outfile << P << " occurs " << count << " times in the input string." << endl;
}

/*===========================================================================*/
/*===========================================================================*/
int StringMatch::mod(int val, int power, int mod)
{

  // Calculate val^power mod "mod"

}

/*===========================================================================*/
/*===========================================================================*/
void StringMatch::RabinKarpMatcher(string P, int d, int q)
{
  int n = Text.length();	// Length of the whole Text
  int m = P.length();		// Length of the Search String
  int h = mod(d, m-1, q);
  int p = 0;			// Hash value of Search String
  int t = 0;			// Hash value of Text Strings
  int i;			// Counter
  int count(0);			// counts # matches

  ofstream outfile(OUTFILE, ios::app); // append to output file

  //Fill in the Rabin-Karp algorithm here

  outfile << P << " occurs " << count << " times in the input string." << endl;
}

/*===========================================================================*/
/*===========================================================================*/
void StringMatch::KMPMatcher(string P)
{
  int n = Text.length();	// Length of the whole Text
  int m = P.length();		// Length of the Search String
  int pi[m+1];
  ComputePrefixFunction(P, pi);
  int q = 0;
  int count(0);			// Counts # matches

  ofstream outfile(OUTFILE, ios::app); // append to output file

  //Fill in the Knuth-Morris-Pratt algorithm here

  outfile << P << " occurs " << count << " times in the input string." << endl;
}

/*===========================================================================*/
/*===========================================================================*/
int * StringMatch::ComputePrefixFunction(string P, int * pi)
{
  int m = P.length();
  int k = 0;

  pi[0] = 0;
  for (int q = 1; q < m; q++){
    while((k > 0) && P[k] != P[q])
      k = pi[k-1];
			
    if (P[k] == P[q])
      k++;
    pi[q] = k;
  }
  return pi;
}

/*===========================================================================*/
/*===========================================================================*/
