/* 
   Algorithms IE171/Spring 2005 - Lab12 - String Matching Algorithms
   Author:  Meredith Somers
   Revision: scott, asm4: 2005
*/

/*===========================================================================*/
/*===========================================================================*/
#include <string>
#include <iostream>
#include <fstream>
#define OUTFILE "results.txt"

using namespace std;

/*===========================================================================*/
/*===========================================================================*/

class StringMatch
{

public:

	//constructors and destructor
	StringMatch(ifstream& is);
	~StringMatch(){};

	//Methods used to search for the pattern in the text
	void NaiveMatcher(string P);
	void RabinKarpMatcher(string P, int d, int q);
	int *ComputePrefixFunction(string P, int * pi);
	void KMPMatcher(string P);

private:
	
	int mod(int a, int b, int n);  
	string Text; //text T to be searched
        string ResultFile;
};
