/*
  File:    queueNumeric.hpp
  Author:  Matthew Galati, Yan Xu, Ted Ralphs, Andrew Ross
  Date:    04/07/03
  Course:  IE 170, Lab 9
*/

/*------------------------------------------------------------------------*/
#include <iostream>
using namespace std;

/*------------------------------------------------------------------------*/
class QueueNumeric{
private:
  // lambda = arrival rate of incoming calls (calls per hour)
  double pArrRate;

  // mu = rate of service, where 1/mu = is the mean call time (in hours)
  double pSvcRate;
  
  // s = number of customer service agents / servers available
  int serversNum;

  // K = system size / the maximum num of customers can be in the system
  int systemSize;

  // Storage arrays for quick calculation (p_n, a^n, n!)
  double * probArray; 
  double * trafficPower;
  double * nFactorial;

private:
  double traffic();             // a   = lambda * (1/mu)
  double relativeUtilization(); // rho = a / s 

  void calculateFactorials();
  void calculateTrafficPowers();
  void initialize();
  int errorCheck();
  void errorMessage(const int errorCode);
  void output(const double & Pb, const double & Pd,
	      ostream * os = &cout);
  
public:
  QueueNumeric();
  QueueNumeric(double pArrR, double pSvcR, int aServ, int serv);
  ~QueueNumeric();
  void MMSK_O(); 
};
